from random import randint, seed, shuffle

def save(fname,seq):
    print(fname)
    f = open(fname,'w')
    print(len(seq), file=f)
    print(*seq, file=f)
    f.close()

def get_distinct(N):
    S = set()
    while len(S) < N: S.add( randint(1,10**9) )
    return list(sorted(S))

def gen_random(N):
    A = get_distinct(N)
    shuffle(A)
    return A

def gen_dashv(N):
    preflen = max(1, N//3 - 2)
    prefix = list(range(1,preflen+1))
    lo, hi = preflen+1, N+1
    suffix = []
    while hi - lo > 0:
        suffix.append(lo)
        lo += 1
        if lo != hi:
            hi -= 1
            suffix.append(hi)
    return prefix + suffix[::-1]

def gen_sqrt(N):
    s = 1
    while s*s < N: s += 1
    answer = []
    lo = 1
    while lo <= N:
        piece = range(lo,min(lo+s,N+1))
        answer.extend( piece[::-1] )
        lo += s
    return answer

def gen_inc(N):
    s = 1
    answer = []
    lo = 1
    while lo <= N:
        piece = range(lo,min(lo+s,N+1))
        answer.extend( piece[::-1] )
        lo += s
        s += randint(0,1)
    return answer

def gen_inc2(N):
    s = 1
    answer = []
    lo = 1
    bol = False
    while lo <= N:
        if lo > N*0.2 and not bol:
            bol = True
            piece = range(lo,min(lo+1+N//10,N+1))
            lo += 1+N//10
        else:
            piece = range(lo,min(lo+s,N+1))
            lo += s
        answer.extend( piece[::-1] )
        s += randint(0,1)
    return answer

MAXN = [ None, 6, 12, 20, 60, 100, 5000, 17000, 150000, 250000, 500000 ]

for tid in range(1,11):
    for letter, strategy in zip('abcdefghijklmnopqrst', [ gen_random, gen_random, gen_dashv, gen_sqrt, gen_inc, gen_inc2 ]):
        fname = '{:02d}.{}.in'.format(tid,letter)
        seed(fname)
        N = MAXN[tid]
        save(fname,strategy(randint(9*N//10,N)))



